unit DllShare;

interface

uses Windows;

type
  TDllInitProc = procedure (DllInitData: Pointer; DataSize: DWord); stdcall;

  PGameTranslationDllInitData = ^TGameTranslationDllInitData;
  TGameTranslationDllInitData = record
    SkipExeChecks: Boolean;

    FontName: array[0..49] of WideChar;
    FontWidth: Byte;
    FontHeight: Byte;
    FontWeight: Integer;
    SpaceWidth: Byte;
      EllipsisWidth: Byte;
    NarrowKerning: Boolean;
    ConvertJpnSymbols: Boolean;
  end;

{$I IncludeCommon.pas}

const
  TargetName = '~True World~';
  TargetExe  = 'T_WORLD.exe';

  TargetExeSize  = 270336;
  TargetExeCRC32 = $5C11B745;

  AppWindowTitle: WideString = TargetName + ' ' + TranslationName + ' | 9.04.2023 | http://proger.me/vn';
  ForceReplayTexts = False;
  ForceFirstText = '';
  // For SetDefaultDllSettingsTo.
  DefaultFont: WideString = 'Lucida Console';
  DefaultFontWidth = 24;
  DefaultFontHeight = 48;
  NarrowKerning = True;
  // It would look better disabled but Lucida Console is not a complete Unicode font.
  ConvertJpnSymbols = True;
  PauseOnLargeFont = True;

procedure SetDefaultDllSettingsTo(var Settings: TGameTranslationDllInitData);

implementation

procedure SetDefaultDllSettingsTo(var Settings: TGameTranslationDllInitData);
begin
  ZeroMemory(@Settings, SizeOf(Settings));

  Move( DefaultFont[1], Settings.FontName[0], Length(DefaultFont) * 2 );
  Settings.FontWidth := DefaultFontWidth;
  Settings.FontHeight := DefaultFontHeight;
  Settings.SpaceWidth := DefaultFontWidth div 2;
    Settings.EllipsisWidth := DefaultFontWidth;
  Settings.NarrowKerning := NarrowKerning;
  Settings.ConvertJpnSymbols := ConvertJpnSymbols;
end;

end.
