program Translate;

uses
  Windows,
  SysUtils,
  UnicodeUtils,
  DllInjector,
  DllShare;

//{$R *.res}
{$I IncludeEXE.pas}

function SemFileExists(S: String): Boolean;
var
  F: TSearchRec;
  OldErrorMode: UInt;
begin
  // Without this Windows shows "drive not ready - continue/ignore/abort" message
  // box if trying to check for a file on an ejected CD-ROM.
  OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
{$I-}
  Result := FindFirst(S, faAnyFile, F) = 0;
  FindClose(F);
{$I+}
  SetErrorMode(OldErrorMode);
end;

var
  InitData: TGameTranslationDllInitData;
  DllToInject: WideString = '.\True World - ' + Language + '.dll';
  EXE: String;
  Letter: Char;
begin
  ChDir( ExtractFilePath(ParamStrW(0)) );

  SetDefaultDllSettingsTo(InitData);

  try
    if ParamCount > 0 then
      DllToInject := ParamStrW(1);

    EXE := '.\' + TargetExe;
    Letter := 'Z';
    while not SemFileExists(EXE) and (Letter >= 'A') do
    begin
      EXE := Letter + ':\' + TargetExe;
      Dec(Letter);
    end;

    if not SemFileExists(EXE) then
      raise EAbort.CreateFmt(LaunchExeError, [TargetExe]);

    if not FileExists(DllToInject) then
      DllToInject := 'Translation.dll';

    InjectDllInto(EXE, DllToInject, InitData, SizeOf(InitData));
  except
    on E: Exception do
      MessageBox(0, PChar(Format('Sorry, couldn''t start up. Error:'#10#10'%s'#10#10'GetLastError = %d', [E.Message, GetLastError])),
                 'https://proger.me/vn', mb_IconStop or mb_SystemModal);
  end;
end.
