#include <stdio.h>
#include <windows.h>
#include <wincrypt.h>

int main(void) {
  HCRYPTPROV hCryptProv;
  if (!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_AES, 0)) {
    printf("1 %x\n", GetLastError());
    return 1;
  }

  HCRYPTHASH hHash;
  if (!CryptCreateHash(hCryptProv, CALG_SHA_512, 0, 0, &hHash)) {
    printf("2 %x\n", GetLastError());
    return 2;
  }

  char data[] = "abcdef";
  if (!CryptHashData(hHash, data, sizeof(data) - 1, 0)) {
    printf("3 %x\n", GetLastError());
    return 3;
  }

  unsigned char hash[64];
  DWORD len = sizeof(hash);
  if (!CryptGetHashParam(hHash, HP_HASHVAL, hash, &len, 0)) {
    printf("4 %x\n", GetLastError());
    return 4;
  }

  for (int i = 0; i < len; i++) {
    printf("%02x", hash[i]);
  }

  printf("\n");

  // ---

  unsigned char encrypted[] = "\x53\x00\xb1\x9c\x3d\x8e\xf3\xbc\x2f\xfc\x7a\x00\xa1\x4d\x9c\x52";
  char *key = hash;
  char *iv = hash + 32;
  len = sizeof(encrypted) - 1;

  __attribute__ ((packed))
  struct {
    BLOBHEADER hdr;
    DWORD dwKeySize;
    BYTE rgbKeyData[32];
  } keyStr = {{PLAINTEXTKEYBLOB, CUR_BLOB_VERSION, 0, CALG_AES_256}, 32};
  memcpy(keyStr.rgbKeyData, key, 32);

  HCRYPTKEY hKey;
  if (!CryptImportKey(hCryptProv, (const BYTE *) &keyStr, sizeof(keyStr), 0, 0, &hKey)) {
    printf("5 %x\n", GetLastError());
    return 5;
  }

  if (!CryptSetKeyParam(hKey, KP_IV, iv, 0)) {
    printf("6 %x\n", GetLastError());
    return 6;
  }

  DWORD pad = PKCS5_PADDING;
  if (!CryptSetKeyParam(hKey, KP_PADDING, &pad, 0)) {
    printf("7 %x\n", GetLastError());
    return 7;
  }

  if (!CryptDecrypt(hKey, 0, 1, 0, encrypted, &len)) {
    printf("8 %x\n", GetLastError());
    return 8;
  }

  for (int i = 0; i < len; i++) {
    //printf("%02x", encrypted[i]);
  }

  encrypted[len] = 0;
  printf("%s\n", encrypted);

  CryptDestroyKey(hKey);
  CryptDestroyHash(hHash);
  CryptReleaseContext(hCryptProv, 0);
}