program utf2sjs;

{$APPTYPE CONSOLE}
{$WARN SYMBOL_PLATFORM OFF}

uses
  SysUtils,
  Windows,
  StrConv,
  UnicodeUtils;

var
  I: Integer = 1;
  S: String;
  F: THandle;
  Len: DWord;
begin
  if ParamCount = 0 then
  begin
    WriteLn(ExtractFileName(ParamStr(0)) + ' takes path(s) to UTF-8 files, converts each to Shift-JIS'#10 +
            'and saves it to the current folder using original files'' base names.'#10#10 +
            'Example: ' + ExtractFileName(ParamStr(0)) + ' bsr_00.txt ..\nie_02.txt'#10 +
            'saves bsr_00.sjs and nie_02.sjs to the current folder.'#10#10 +
            'https://proger.me/vn | public domain');
    ExitProcess(1);
  end;

  // Windows 10's cmd.exe (interactive or batch) inserts two spaces rather than
  // one between the program's file and the first argument. ParamStrW doesn't
  // skip over empty arguments so hardcoding this check for that specific
  // case.
  if ParamStrW(1) = '' then
    Inc(I);

  try
    while ParamStrW(I) <> '' do
    begin
      F := CreateFileW(PWideChar(ParamStrW(I)), GENERIC_READ, FILE_SHARE_READ, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
      Win32Check(F <> INVALID_HANDLE_VALUE);
      Len := GetFileSize(F, NIL);
      SetLength(S, Len);
      ReadFile(F, S[1], Len, Len, NIL);
      CloseHandle(F);

      S := FromWideString(CP_SHIFTJIS, ToWideString(CP_UTF8, S), -1, True);
      Len := Length(S);

      F := CreateFileW(PWideChar(ChangeFileExt(ExtractFileName(ParamStrW(I)), '.sjs')), GENERIC_WRITE, 0, NIL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
      Win32Check(F <> INVALID_HANDLE_VALUE);
      WriteFile(F, S[1], Len, Len, NIL);
      CloseHandle(F);

      Inc(I);
    end;
  except
    on E: Exception do
    begin
      WriteLn(E.Message);
      ExitProcess(1);
    end;
  end;
end.
